﻿// This function toggles the flyout view
function ShowFlyout() {

if (System.Gadget.Flyout.show==true) {
                                      System.Gadget.Flyout.show=false;
                                     }else {
                                            System.Gadget.Flyout.show=true;
                                           }

}


// This function is called by the flyout document and populates it with the forecasts
// I know that it´s not so graceful that it is calling the ajax-fetching process four times, but it´s anyway
// a kind o modular solution. The best thing would be to cache all XML data on the first initial request
// and then use it for the flyout.
function LoadFlyout () {
                            var step=System.Gadget.Settings.read("forecast_step"); 
                            var correction=System.Gadget.Settings.read("step_correction"); 

                            do_forecast('1',eval(step + correction));
                            do_forecast('2',eval(2*step + correction));
                            do_forecast('3',eval(3*step + correction));
                            do_forecast('4',eval(4*step + correction));
                       }



var start_count=0; // This variable is only for debugging purposes


function do_forecast(updatediv,fetch_forecast) {


var AJAX = null;
AJAX=new XMLHttpRequest();


AJAX.onreadystatechange = function() {

if (AJAX.readyState==4 || AJAX.readyState=="complete") {


// Here we parsing the XML-data that we got from yr.no
var xmldoc=AJAX.responseXML.documentElement;
var forecast_time=xmldoc.getElementsByTagName('tabular').item(0).getElementsByTagName('time').item(fetch_forecast).getAttribute('from');
var forecast_time_to=xmldoc.getElementsByTagName('tabular').item(0).getElementsByTagName('time').item(fetch_forecast).getAttribute('to');
var forecast_period=xmldoc.getElementsByTagName('tabular').item(0).getElementsByTagName('time').item(fetch_forecast).getAttribute('period');
var symnum=xmldoc.getElementsByTagName('tabular').item(0).getElementsByTagName('time').item(fetch_forecast).getElementsByTagName('symbol').item(0).getAttribute('number');
var temperature=xmldoc.getElementsByTagName('tabular').item(0).getElementsByTagName('time').item(fetch_forecast).getElementsByTagName('temperature').item(0).getAttribute('value');
var wind_speed=xmldoc.getElementsByTagName('tabular').item(0).getElementsByTagName('time').item(fetch_forecast).getElementsByTagName('windSpeed').item(0).getAttribute('mps');
var precipitation=xmldoc.getElementsByTagName('tabular').item(0).getElementsByTagName('time').item(fetch_forecast).getElementsByTagName('precipitation').item(0).getAttribute('value');
var sunrise=xmldoc.getElementsByTagName('sun').item(0).getAttribute('rise');
var sunset=xmldoc.getElementsByTagName('sun').item(0).getAttribute('set');
var link_url=xmldoc.getElementsByTagName('link').item(0).getAttribute('url');
var city=xmldoc.getElementsByTagName('name').item(0).childNodes.item(0).data;
var country=xmldoc.getElementsByTagName('country').item(0).childNodes.item(0).data;


// Some logical handling is done here, in order to always show the correct weathersymbol. We must manipulate symnum!
// It all is dependent on the value of the number and wether it's day or not.

var split_time=forecast_time.split('T');
var split_time_to=forecast_time_to.split('T');
var between_time=split_time[1].replace(/.{3}$/,"") + " - " + split_time_to[1].replace(/.{3}$/,"");

// All symbolnumbers below 10, must be preceded by a zero
if (symnum<10) { symnum="0"+ symnum; }  


// Symbol number 4 and 9 and above is symbols looking the same no matter, it´s day or night. We must avoid alter them!


// Here we try to find out wether it´s night or day and then add the needed token at the end of the number
if (forecast_period=="0"||forecast_period=="3") {
                                if (symnum!="04" && symnum<9) { symnum=symnum + "n"; }
                                var divbgimg="images/nightbg.png";
                                var temptextcolor="#ff0000";
  }else {
        if (symnum!="04" && symnum<9) { symnum=symnum + "d"; }
        var divbgimg="images/daybg.png";
        var temptextcolor="#000000";
        }



var current_date=new Date();
var forecast_date=new Date(split_time[0].replace("-","/"));             


var current_day=current_date.getDay();
var forecast_day=forecast_date.getDay();

// Mapping Today,Tomorrow or the weekday with the date of the forecast
if (current_day==forecast_day) { showing_weekday=l_Today + " " + between_time;
}else if (forecast_day==current_day+1) { 
                                        var showing_weekday=l_Tomorrow + " " + between_time;
                                       }else {
                                              var showing_weekday=l_Weekdays[forecast_day] + " " + between_time;
                                             } 
                                     


// This little neat function ensures that any too long strings not will cause any displaying problems in the gadget
// The function trims down the string if it exceeds chosen max length.
function trimvar(varname,maxlen) {
if (varname.length>maxlen) {
var cut_token=varname.length-maxlen;
return(varname.replace(new RegExp(".{"+ cut_token + "}$"),""));
}else { return(varname); }
}

city=trimvar(city,10);
country=trimvar(country,10);


// Here we try to find out the right stepvalue for weather to use when Gadget is undocked
// Any incorrect values may cause wrong days to be displayed, in most cases is 4 the right value,  with some exceptions.
// Some correction has to be applied, due to which period

if (fetch_forecast==0) {

switch(between_time) {
case "23:00 - 05:00":
System.Gadget.Settings.write("forecast_step","3");
break;

case "23:30 - 05:30":
System.Gadget.Settings.write("forecast_step","3");
break;

default:
System.Gadget.Settings.write("forecast_step","4");
break;
}

switch(forecast_period) {
case "0":
System.Gadget.Settings.write("step_correction","-3");
break;
case "2":
System.Gadget.Settings.write("step_correction","-1");
break;
case "3":
System.Gadget.Settings.write("step_correction","-2");
break;
default:
System.Gadget.Settings.write("step_correction","");
break;
}

}


RenderHTML(showing_weekday, symnum, temperature, wind_speed, precipitation, link_url, city, country,
divbgimg, temptextcolor, updatediv, fetch_forecast, AJAX.status); // Here we call the RenderHTML function with processed data

} // End Ajax readystate check

} // End of readystatechange event



var url=System.Gadget.Settings.read("locationURL"); // This is the URL we will call.
if (url=="") { url="http://www.yr.no/place/Norway/Oslo/Oslo/Oslo/forecast.xml"; } // Default location on first startup
url=encodeURI(url);
AJAX.open("GET", url, true); // Open the url this object was set-up with.
AJAX.send(null); // Send the request.

} // End of do_forecast


// This function is the one, that returns anything for the user to see. It updates the selected div-tag with the right data.
function RenderHTML(forecasttime, symnr, temp, wind_spd, precip, linkurl, cityname,
countryname, divbgimg, temptextcolor, updatediv, fetch_forecast, serverStatus) {

++start_count; // Counter for the loop

// Checks if the fahrenheit-option was enabled or not
if (System.Gadget.Settings.read("Fahrenheit")=="1") {
temp=Math.round(1.8*temp+32);
var tempsym="&#176;F";
} else {
var tempsym="&#176;";
}

document.getElementById('weather' + updatediv).style.background="url(images/60x50/" + symnr + ".png) right bottom no-repeat";
document.getElementById('outer' + updatediv).style.background="url(" + divbgimg + ") center no-repeat";
document.getElementById('weather' + updatediv).style.color="#000000";
document.getElementById('weather' + updatediv).innerHTML="\
<font face=\"#arial, helvetica\" size=\"1\">\
<b>" + cityname + ", " + countryname + "<br>" + forecasttime + "<br>\
<font size=\"1\">" + l_Wind + " " + wind_spd + " m/s</font><br>\
<font size=\"1\">"+ l_Precipitation + " " + Math.round(precip) + " mm</font><br>\
" + l_Forecast_from + " <a href=\"" + linkurl + "\" target=\"_blank\">yr.no</b></a><br>&nbsp;<br>&nbsp;<br>&nbsp;<br>\
<div align=\"right\"><b><font color=\"" + temptextcolor + "\" size=\"5\">" + temp + tempsym + "&nbsp;</font></b></div>\
<div id=\"flyout-trigger\"></div></font>";


if (fetch_forecast=="0") {
System.Gadget.Flyout.file="flyout.html";
timer=setTimeout('do_forecast(\'0\',\'0\')',3600000);
document.getElementById('flyout-trigger').innerHTML="\
<a onmouseover=\"javascript:document.button.src='images/button2.png'\" onmouseout=\"\
javascript:document.button.src='images/button1.png'\" href=\"javascript:ShowFlyout();\"\
><img name=\"button\" src=\"images/button1.png\" border=\"0\"></a>";
}


} // End of RenderHTML
